config/routes.rb
Invoicing::Engine.routes.draw do

  post 'invoice/move_invoice_items/:invoice_id/:invoice_status_id' => 'invoices#move_invoice_items', :as => :move_invoice_items
  post 'invoice/export_invoices' => 'invoices#export_invoices', :as => :export_invoices
  post 'invoice/:id/toggle_pages' => 'invoices#toggle_pages', :as => :invoices_toggle_pages
  post 'invoice/:search_invoice_id/mark_ready' => 'invoices#mark_ready', :as => :invoices_mark_ready
  get 'invoices/review_send_to_client' => 'invoices#review_send_to_client', :as => :invoices_review_send_to_client
  get 'invoices/check_projects' => 'invoices#check_projects', :as => :invoices_check_projects
  match 'invoices/index/(:id)' => 'invoices#index', :as => :index_invoices, :via => [:get,:patch]
  match 'invoices/generate_excel_from_previous_month', :as => :generate_excel_from_previous_month, :via => [:get]
  get 'invoices/agresso' => 'invoices#agresso', :as => :agresso
  post 'invoice/:invoice_id/update_status' => 'invoices#update_status', :as => :update_status_invoice
  get 'invoice/:invoice_id/send_single' => 'invoices#send_single', :as => :send_single_invoice
  get 'invoice/:invoice_id/send_single_to_client' => 'invoices#send_single_to_client', :as => :send_single_to_client_invoice
  match 'invoice/:user/send_all' => 'invoices#send_all', :as => :send_all_invoices, :via => [:post]
  get 'invoice/:invoice_id/preview' => 'invoices#preview', :as => :preview_invoice
  get 'invoice/:invoice_id/credit' => 'invoices#credit', :as => :credit_invoice

  post 'invoice/:search_invoice_id/check_invoices' => 'invoices#check_invoices', :as => :check_invoices
  get 'invoice/invoice_pdf' => 'invoices#invoice_pdf', :as => :invoice_pdf
  get 'invoice_items/edit/:invoice_id' => 'invoice_items#edit', :as => :edit_invoice_item_for_invoice, :via => [:get]

  resources :invoice_items
  get 'invoice_items/new/:invoice_id' => 'invoice_items#new', :as => :new_invoice_item_for_invoice

  root :to => 'invoices#index'
end

app/models/invoicing/invoice_item.rb
module Invoicing
  class InvoiceItem < ActiveRecord::Base
    belongs_to :invoice

    belongs_to :project, class_name: Invoicing.project_class.to_s
    belongs_to :report, class_name: Invoicing.report_class.to_s
    belongs_to :author, class_name: Invoicing.author_class.to_s
    belongs_to :valuation_firm, class_name: Invoicing.valuation_firm_class.to_s

    validates :valuation_firm_id, :presence => true

    before_create do
      #beginningOfMonth = DateTime.parse(it.created_at.to_s).beginning_of_month
      currentMoment    = self.created_at ||= Time.zone.now
      beginningOfMonth = self.created_at.nil? ? DateTime.now.in_time_zone(Time.zone).beginning_of_month : DateTime.parse(self.created_at.to_s).beginning_of_month
      #currentMoment    = self.created_at ||= Time.zone.now

      if self.invoice_id.nil?
        invoices = Invoicing::Invoice.where(invoice_status_id: InvoiceStatus.find_by_value(InvoiceStatus::STATUS[:pending_send]).id).
                      where(valuation_firm_id: self.valuation_firm_id).
                      where('created_at BETWEEN ? AND ?', beginningOfMonth, currentMoment).
                      order(:created_at)

        if invoices.empty?
          self.create_invoice!(valuation_firm_id: self.valuation_firm_id, author_id: self.author_id,
                               invoice_status_id: InvoiceStatus.find_by_value(InvoiceStatus::STATUS[:pending_send]).id,
                               last_updated_by_id: self.author_id, created_at: beginningOfMonth, search_date: beginningOfMonth)
        else
          self.invoice = invoices.first
        end
      end
    end

    def readonly?
      (!self.invoice_id.nil? && !self.invoice.can_edit?) ||
          (!self.invoice_id.nil? && self.invoice.invoice_status_id_was == InvoiceStatus.find_by_value(InvoiceStatus::STATUS[:ready_to_send]).id)
    end

    def invoice_details
      unless project_id.blank?
        "#{project.project_name} #{project.waterman_ref} #{author.full_name} #{project.your_ref} #{project.invoice_created}"
      else
        project.description
      end
    end

    def other_proposals
      Invoice.where(
        'id <> ? and invoice_status_id = ?',
        invoice_id,
        InvoiceStatus.find_by_value(InvoiceStatus::STATUS[:pending_send]).id
      )
    end
  end
end

app/models/invoicing/invoice_number.rb
module Invoicing
  class InvoiceNumber < ActiveRecord::Base
    has_one :invoice
    validates :value, uniqueness: true

    before_create do |invNumber|
      # Generate the next consecutive invoice number
      prefix = Invoicing.invoiceNumberPrefix
      digits = Invoicing.invoiceNumberDigits

      lastInvoiceNumber = Invoicing::InvoiceNumber.where('value LIKE ?', "#{prefix}%").order('value desc').first

      if lastInvoiceNumber
        lastNumber = lastInvoiceNumber.value.split(prefix)[1].to_i
        invNumber.value = prefix + (lastNumber + 1).to_s.rjust(digits, '0')
      else
        invNumber.value = prefix + '1'.rjust(digits, '0')
      end
    end

  end
end

app/models/invoicing/invoice_status.rb
module Invoicing
  class InvoiceStatus < ActiveRecord::Base
    has_many :invoices

    STATUS = {
        :pending_send   => 'invoice proposal',
        :ready_to_send  => 'ready to send',
        :sent_to_client => 'sent to client',
        :exported       => 'exported'
    }

    def self.can_edit
        [find_by_value(Invoicing::InvoiceStatus::STATUS[:pending_send]).id]
    end

    def self.can_credit
        [find_by_value(Invoicing::InvoiceStatus::STATUS[:exported]).id,find_by_value(Invoicing::InvoiceStatus::STATUS[:sent_to_client]).id]
    end

  end


end

app/controllers/invoicing/application_controller.rb
# module Invoicing
#   class ApplicationController < ::ApplicationController
#   end
# end

class Invoicing::ApplicationController < ApplicationController
  layout 'layouts/admin'
  load_and_authorize_resource unless Rails.env == "test"
end

app/controllers/invoicing/invoice_items_controller.rb
require_dependency "invoicing/application_controller"

module Invoicing
  class InvoiceItemsController < ApplicationController
    def new
      # Expected key should be invoice_id vlad
      if params.has_key? 'id'
        invoice_id=params[:id]
      elsif params.has_key? 'invoice_id'
        invoice_id=params[:invoice_id]
      end
      unless invoice_id.nil?
        @invoice = Invoicing::Invoice.find(invoice_id)
        @invoiceItem = Invoicing::InvoiceItem.new(:invoice_id => @invoice.id, :valuation_firm_id => @invoice.valuation_firm_id)
      else
        @invoiceItem = Invoicing::InvoiceItem.new
      end
    end

    def show
      @invoiceItem = Invoicing::InvoiceItem.find(params[:id])
    end

    def edit
      @invoiceItem = Invoicing::InvoiceItem.find(params[:id])
    end

    def update
      @invoiceItem = Invoicing::InvoiceItem.find(params[:id])

      if @invoiceItem.update_attributes(invoice_item_params)
        redirect_to index_invoices_path, notice: 'Invoice item was successfully updated.'
      else
        render action: "edit"
      end
    end

    def create
      @invoiceItem = Invoicing::InvoiceItem.new(invoice_item_params)

      if @invoiceItem.save
        redirect_to index_invoices_path, notice: 'Invoice Item was successfully created.'
      else
        render action: "new"
      end
    end

    def destroy
      @invoiceItem = Invoicing::InvoiceItem.find(params[:id])
      if !@invoiceItem.readonly?
        @invoiceItem.destroy
      end

      redirect_to index_invoices_path
    end

    private

    def invoice_item_params
      params.require(:invoice_item).permit(:author_id, :amount, :description,
        :vat, :invoice_id, :project_id, :valuation_firm_id)
    end

  end

end

app/controllers/invoicing/invoices_controller.rb
require_dependency "invoicing/application_controller"


module Invoicing
  class InvoicesController < ApplicationController
  load_and_authorize_resource unless Rails.env == "test"
  #after_filter :save_html, :only => :index

     def save_html
      File.open('/tmp/makehtml.xls', 'w') do |f|
        f.write response.body
      end
    end

    def check_projects
      @start_date = params[:start_date]
      @start_date ||= "01/#{Time.zone.now.month}/#{Time.zone.now.year}"
      @end_date = params[:end_date]
      @end_date ||= "#{Time.zone.now.end_of_month.day}/#{Time.zone.now.month}/#{Time.zone.now.year}"
      @projects = Project.issue_date_search(@start_date,@end_date)

      respond_to do |format|
        format.html
        format.xls do
          headers["Content-Disposition"] = "attachment; filename=\"check_project_list.xls\""
        end
      end

    end

    def agresso
      @agressos=Agresso.order("id DESC")
    end

    def credit
      invoice = Invoicing::Invoice.find(params[:invoice_id])
      # Refactor mtj todo
      # Credit note
      @invoice = invoice.credit(current_user.id)
      @invoice.generate_invoice_pdf(@invoice.pdf_filename,true)

      # Invoice
      @invoice = invoice.reissue(current_user.id)

      redirect_to index_invoices_path, notice: "A credit note for this invoice has been created."
    end

    def mark_ready
      search_invoice = SearchInvoice.find(params[:search_invoice_id])
      Invoice.mark_all_ready(search_invoice, current_user)
      redirect_to index_invoices_path, notice: "Invoice proposals are being marked ready to send."
    end

    def check_invoices
      search_invoice = SearchInvoice.find(params[:search_invoice_id])
      search_invoice.update_attributes(:invoice_status_id => InvoiceStatus.find_by_value(InvoiceStatus::STATUS[:pending_send]).id)
      Invoice.delay.generate_multiple_invoices_pdf(search_invoice)
      search_invoice.update_attributes(:invoice_status_id => InvoiceStatus.find_by_value(InvoiceStatus::STATUS[:ready_to_send]).id)
      Invoice.delay.generate_multiple_invoices_pdf(search_invoice)
      redirect_to index_invoices_path, notice: "Invoice proposals have been sent."
    end

    def index
      if params[:reset].present?
        @search_invoice=SearchInvoice.create
      else
        if params[:search_invoice].present?
          @search_invoice=SearchInvoice.create(search_invoice_params)
        else
          if params[:id].present?
            @search_invoice=SearchInvoice.find(params[:id].to_i)
          elsif SearchInvoice.exists?(session[:search_id].to_i)
            @search_invoice=SearchInvoice.find(session[:search_id].to_i)
          else
            @search_invoice=SearchInvoice.create
          end
        end
      end
      session[:search_id] = @search_invoice.id
      respond_to do |format|
        format.html do
          if is_consultant?
            @invoices = Invoice.search(@search_invoice)
          elsif is_valuer? && is_super_user?
            if current_user.valuation_firm.company_name && @search_invoice.update_attributes(:valuation_firm => current_user.valuation_firm.company_name)
              @invoices = Invoice.valuer_search(@search_invoice)
            else
              @invoices = []
            end
          else
            @invoices = []
          end
        end
        format.xls do
          headers["Content-Disposition"] = "attachment; filename=\"invoice_list.xls\""
          @invoices = Invoice.excel_search(@search_invoice)
        end
      end
    end

    def update_status
      @invoice = Invoicing::Invoice.find(params[:invoice_id])
      invoice_status = Invoicing::InvoiceStatus.find(params[:invoice_status_id])

      if !@invoice.available_statuses.include?(invoice_status)
        flash[:error] = 'Invalid invoice status'
      elsif @invoice.invoice_status_id != invoice_status.id
        @invoice.invoice_status = invoice_status
        @invoice.last_updated_by_id = current_user.id

        if invoice_status.id == InvoiceStatus.find_by_value(InvoiceStatus::STATUS[:ready_to_send]).id
          @invoice.generate_invoice_pdf(@invoice.pdf_filename,true)
        end

        begin
          @invoice.save
        rescue
          flash[:error] = 'There was an error updating the invoice status'
        end
      end

      redirect_to :index_invoices
    end

    def preview
      @invoice = Invoicing::Invoice.find(params[:invoice_id])
      authorize! :preview, @invoice
      #render :file => 'invoicing/invoice_mailer/send_single_invoice.html.erb', :layout => false

      if @invoice.can_edit?
        # Remove temp file if it exists
        File.delete(@invoice.pdf_filename) if File.exist?(@invoice.pdf_filename)

        @invoice.generate_invoice_pdf(@invoice.pdf_filename)

        while (!FileReady.new(@invoice.pdf_filename).all_ready?)
          sleep(0.5)
        end
        sleep(2)
        send_file @invoice.pdf_filename,:type => 'application/pdf', :disposition => 'inline'
      else
        send_file @invoice.invoice_path,:type => 'application/pdf', :disposition => 'inline'
      end
    end

    def send_single
      invoice = Invoicing::Invoice.find(params[:invoice_id])
      Invoice.send_single(current_user,[invoice])
      redirect_to index_invoices_path, notice: "A copy of the invoice has been sent to #{current_user.email}."
    end

    def send_single_to_client
      invoice = Invoicing::Invoice.find(params[:invoice_id])
      if Invoice.send_single_to_client([invoice])
        redirect_to index_invoices_path, notice: "The invoice has been sent to the client."
      else
        redirect_to index_invoices_path, error: "Failed sending this invoice."
      end
    end

    def send_all
      if params[:user].present? && params[:user]=="current"
        Invoice.delay.send_all(current_user)
      else
        Invoice.delay.send_all(nil)
      end
      redirect_to index_invoices_path, notice: "All invoices are being sent."
    end

    private

    def search_invoice_params
      params.require(:search_invoice).permit(:valuation_firm, :start_date, :end_date, :invoice_status_id, :invoice_number)
    end

    def review_send_to_client
      @invoices = Invoice.all_ready_to_send
    end

    def toggle_pages
      invoice = Invoicing::Invoice.find(params[:id])
      if invoice.update_attributes(:multiple_pages => !invoice.multiple_pages)
        redirect_to index_invoices_path, notice: invoice.multiple_pages_flash_message
      else
        redirect_to index_invoices_path, notice: "The change failed to save."
      end
    end

    def export_invoices
      Invoice.delay.generate_agresso_xls
      redirect_to agresso_path, :notice => "Invoices are being exported."
    end

    def move_invoice_items
      invoice = Invoicing::Invoice.find(params[:invoice_id])
      invoice_item = Invoicing::InvoiceItem.find(params[:invoice_status_id])
      if invoice_item.update_attributes(invoice_id: invoice.id)
        flash_message = 'The invoice item has been moved.'
      else
        flash_message = 'The invoice item failed to move.'
      end
      redirect_to index_invoices_path, notice: flash_message
    end

  end

end

app/helpers/invoicing/application_helper.rb
module Invoicing
  module ApplicationHelper
    # => "12/05/2010"
    def date_ddmmyyyy(the_date)
      the_date.strftime("%d/%m/%Y") unless the_date.nil?
    end

    def time_zone_date_and_time(the_date)
      date_ddmmyy_t(the_date.in_time_zone('London')) unless the_date.nil?
    end

    def date_ddmmyy_t(the_date)
      the_date.strftime("%d/%m/%y %H:%M") unless the_date.nil?
    end

    def quick_link(date)
      @quick_link_search_invoice = SearchInvoice.quick_link_month(date)
      link_to @quick_link_search_invoice.start_date.strftime("%B"),index_invoices_path(@quick_link_search_invoice.id)
    end

    def this_month
      Time.zone.now.strftime("%B %Y")
    end

  end
end

app/views/invoicing/invoices/agresso.html.haml
- content_for :navigation do
  .menu-wrapper= render_navigation
.span-24.last
  %table.projects{:style=>"margin-bottom: 0.4em;"}
    %thead
      %tr
        %th.fst Title
        %th ID
        %th All Invoices
        %th.lst{:style=>"width:250px;"} Spreadsheet
    %tbody
      - @agressos.each do |agresso|
        %tr.short
          %td.with-triangle
            %span{:class => ('completed' if agresso.downloaded?)}= agresso.title
          %td= agresso.id
          %td{:style=>"width:220px;"}
            |
            %span= link_to "Download", agresso.try(:uploads_agresso_all).try(:last).try(:doc).try(:url), :id => 'uploads_agresso_all'
            |
          %td{:style=>"width:220px;"}
            |
            %span= link_to "Download", agresso.uploads_agressos.try(:last).try(:doc).try(:url), :id => 'agresso'
            |

.span-24.footer.last{:style=>"padding:5px 16px 5px 0;"}
  -if Invoicing::Invoice.show_export_button?
    =button_to "Export Sent Invoices", export_invoices_path, :confirm => 'Are you sure?',:style => "margin:0 5px 0 5px;"
  -else
    &nbsp;

app/views/invoicing/invoices/check_projects.haml
- content_for :navigation do
  .menu-wrapper= render_navigation

.span-24.last
  = form_tag invoices_check_projects_path, :method => 'get' do
    %p
      From:
      = text_field_tag 'start_date',@start_date
      To:
      = text_field_tag 'end_date',@end_date
      = submit_tag "Search By Issue Date", :name => nil
      = link_to 'Export to Excel', invoices_check_projects_path(:format => :xls,:start_date => @start_date,:end_date => @end_date)

.span-24.last
  %table.projects
    %thead
      %tr
        %th.fst Project Name
        %th Creator
        %th Creator's Email
        %th Valutation Firm
        %th Client
        %th Valuer Ref
        %th Waterman Ref
        %th Creation Date
        %th Completion Date
        %th Issue Date
        %th Invoice Number
        %th.lst Invoice Status
    %tbody
      - @projects.each do |project|
        -unless project.nil?
          %tr
            %td= h truncated_text(project.project_name)
            %td= project.creator.full_name
            %td= project.creator.email
            %td= project.creator.valuation_firm.company_name
            %td= project.client
            %td= h truncated_text(project.your_ref,2)
            %td= project.waterman_ref
            %td= date_ddmmyy_t(project.project_confirmed_date.in_time_zone('London')) unless project.project_confirmed_date.nil?
            %td= date_ddmmyyyy(project.completion_date)
            %td= date_ddmmyyyy(project.issue_date)
            %td= project.invoice_details
            %td= project.invoice_status

app/views/invoicing/invoices/index.html.haml
- content_for :navigation do
  .menu-wrapper= render_navigation

.span-24.last
  =form_for @search_invoice ,:url=>{:action=>:index}, :html => {:id => :search_invoice} do |f|
    %p
      -if is_consultant?
        =f.label :company
        =f.text_field :valuation_firm, data: {autocomplete_source: ValuationFirm.invoice_search},:id => :valuation_firm
        =f.label :invoice_number
        =f.text_field :invoice_number

      =f.label :from
      =f.text_field :start_date,:value => date_ddmmyyyy(@search_invoice.start_date)
      =f.label :to
      =f.text_field :end_date,:value => date_ddmmyyyy(@search_invoice.end_date)
      =f.select :invoice_status_id, Invoicing::InvoiceStatus.all.collect {|i| [ i.value, i.id ]},{:include_blank => "-- all --"}
      = submit_tag "Search", :name => nil
      = submit_tag "Reset", :name => "reset"
      = quick_link(Date.today - 2.months)
      = quick_link(Date.today - 1.month)
      = quick_link(Date.today)

.span-24.last
  %table.projects#invoices{:style=>"margin-bottom: 0.4em;"}
    %thead
      %tr
        %th.fst Valuation Firm
        %th Invoice Number
        %th Invoice Date
        %th Creation Date
        - if is_consultant?
          %th Status
        %th Amount
        - if is_consultant?
          %th Pages
          %th Ref
          %th.lst{:style=>"width:250px;"} Action
    %tbody
      - @invoices.each do |invoice|
        %tr.short[invoice.valuation_firm]
          %td.with-triangle
            %span= link_to invoice.valuation_firm.company_name, main_app.edit_valuation_firm_path(invoice.valuation_firm.id)
          %td= invoice.display_invoice_number
          %td= date_ddmmyyyy(invoice.invoiced_at)
          %td= date_ddmmyyyy(invoice.created_at)
          - if is_consultant?
            %td= (invoice.available_statuses.count > 1) ? select_tag("status_change_#{invoice.id}",
              options_from_collection_for_select(invoice.available_statuses, :id, :value, invoice.invoice_status_id),
              { 'class' => 'status_selector', 'data-invoice_id' => invoice.id }): invoice.status
          %td= invoice.total_amount
          %td= link_to invoice.multiple_pages_link, invoices_toggle_pages_path(invoice), :method => :post
          - if is_consultant?
            %td= invoice.valuation_firm.invoice_ref
          %td{:style=>"width:220px;"}
            |
            %span= link_to 'Preview ',preview_invoice_path(invoice),'data-popup'=>true
            - if is_consultant?
              |
              - if invoice.can_be_sent?
                %span= link_to 'Send to me ',send_single_invoice_path(invoice)
                |
                %span= link_to 'Send to client', send_single_to_client_invoice_path(invoice), :confirm => 'Are you sure?'
                |
              - if invoice.can_credit?
                %span= link_to 'Credit ',credit_invoice_path(invoice)
              -if !invoice.address_complete?
                %span= link_to 'Add Address', main_app.valuation_firms_return_to_invoice_path(invoice.valuation_firm.id,true)
                |
            = "|" unless is_consultant?

        %tr.details.hidden
          %td{ :colspan => 7}
            = render partial: 'invoicing/shared/invoice_items', locals: {:invoice => invoice}
            -if is_consultant?
              %span= (invoice.can_add_items? ? link_to('Add Invoice Item', new_invoice_item_for_invoice_path(invoice.id), {'class' => 'add_invoice_item' }) : '')

- if is_consultant?
  .span-3.footer{:style=>"padding:5px 8px 5px 0;margin-right:2px;"}
    =link_to 'Exported', index_invoices_path(:format => :xls), :style=>"padding:0 0 0 5px;color:#FFF;"

  .span-4.footer{:style=>"padding:5px 8px 5px 0;margin-right:2px;"}
    =link_to 'Check Invoices', check_invoices_path(@search_invoice), :style=>"padding:0 0 0 5px;color:#FFF;", :method => :post, :confirm => 'Are you sure?'
  .span-3.footer{:style=>"padding:5px 8px 5px 0;margin-right:2px;"}
    =link_to 'Ready to Send', invoices_review_send_to_client_path, :style=>"padding:0 0 0 5px;color:#FFF;"

  .span-4.footer{:style=>"padding:5px 8px 5px 0;margin-right:2px;"}
    =link_to 'Send All to Me', send_all_invoices_path("current"), :style=>"padding:0 0 0 5px;color:#FFF;", :method => :post, :confirm => 'Are you sure? All ready to send invoices will be sent to you.'

  .span-3.footer{:style=>"padding:5px 8px 5px 0;margin-right:2px;"}
    =link_to 'Check Projects', invoices_check_projects_path, :style=>"padding:0 0 0 5px;color:#FFF;"

  .span-4.footer{:style=>"padding:5px 8px 5px 0;margin-right:2px;"}
    =link_to 'Mark All Ready', invoices_mark_ready_path(@search_invoice), :style=>"padding:0 0 0 5px;color:#FFF;", :method => :post, :confirm => 'Are you sure? All invoice proposals will be marked ready to send.'

  .span-3.footer.last{:style=>"padding:5px 0 5px 0;margin-right:0;"}
    =link_to 'Spreadsheet', agresso_path, :style=>"padding:0 0 0 5px;color:#FFF;"

-else
  .span-24.footer.last{:style=>"padding:5px 0 5px 0;"}
    &nbsp;

app/views/invoicing/invoices/index.xls.erb
<?xml version="1.0"?>
<Workbook xmlns="urn:schemas-microsoft-com:office:spreadsheet"
  xmlns:o="urn:schemas-microsoft-com:office:office"
  xmlns:x="urn:schemas-microsoft-com:office:excel"
  xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"
  xmlns:html="http://www.w3.org/TR/REC-html40">
  <Styles>
    <Style ss:ID="s22">
      <NumberFormat ss:Format="dd\ mmm\ yyyy"/>
  </Style>
  </Styles>
  <Worksheet ss:Name="Sheet1">
    <Table>
      <Row>
        <Cell><Data ss:Type="String">Valuation Firm</Data></Cell>
        <Cell><Data ss:Type="String">Invoice Number</Data></Cell>
        <Cell><Data ss:Type="String">Invoice Date</Data></Cell>
        <Cell><Data ss:Type="String">Creation Date</Data></Cell>
        <Cell><Data ss:Type="String">Status</Data></Cell>
        <Cell><Data ss:Type="String">Amount</Data></Cell>
      </Row>
      <% @invoices.each do |invoice| %>
        <Row>
          <Cell><Data ss:Type="String"><%= invoice.valuation_firm.company_name %></Data></Cell>
          <Cell><Data ss:Type="String"><%= invoice.display_invoice_number %></Data></Cell>
          <% if invoice.invoiced_at.nil? %>
            <Cell><Data ss:Type="String"></Data></Cell>
          <% else %>
            <Cell ss:StyleID="s22"><Data ss:Type="DateTime"><%= invoice.excel_invoiced_at %></Data></Cell>
          <% end %>
          <Cell ss:StyleID="s22"><Data ss:Type="DateTime"><%= invoice.excel_created_at %></Data></Cell>
          <Cell><Data ss:Type="String"><%= invoice.invoice_status.value %></Data></Cell>
          <Cell><Data ss:Type="String"><%= invoice.amount %></Data></Cell>
        </Row>
      <% end %>
    </Table>
  </Worksheet>
</Workbook>

app/views/invoicing/invoices/review_send_to_client.html.haml
- content_for :navigation do
  .menu-wrapper= render_navigation

.span-24.last
  %table.projects
    %thead
      %tr
        %th.fst Valuation Firm
        %th Invoice Number
        %th Amount
        %th Recipient Name
        %th.lst Recipient Email Address
    %tbody
      -@invoices.each do |invoice|
        %tr.short
          %td= link_to invoice.valuation_firm.company_name, main_app.edit_valuation_firm_path(invoice.valuation_firm.id)
          %td= invoice.display_invoice_number
          %td= invoice.total_amount
          -if !invoice.client_user
            %td
              %span= link_to 'Add Address', main_app.valuation_firms_return_to_invoice_path(invoice.valuation_firm.id,true)
            %td &nbsp;
          -else
            %td
              =invoice.valuation_firm.client_user.full_name
            %td
              =invoice.valuation_firm.client_user.email

.span-4.footer{:style=>"padding:5px 0px 5px 0;margin-right: 2px;"}
  =link_to 'Back', index_invoices_path, :style=>"padding:0 0 0 5px;color:#FFF;"

.span-4.footer{:style=>"padding:5px 0px 5px 0;margin-right: 2px;"}
  =link_to 'Send All to Clients', send_all_invoices_path("me"), :style=>"padding:0 0 0 5px;color:#FFF;", :method => :post, :confirm => 'Are you sure? All ready to send invoices will be sent to the client.'

.span-16.footer.last{:style=>"padding:5px 16px 5px 0;margin-right: 0;"}
  &nbsp;

app/views/invoicing/invoices/update_status.html.erb
<h1>Invoices#update_status</h1>
<p>Find me in app/views/invoicing/invoices/update_status.html.erb</p>